% \documentclass[noanswers, nolegalese, 11pt]{examjh}
\documentclass[answers, nolegalese, 11pt]{examjh}
\usepackage{../../../../computingfonts}
\usepackage{../../../../contentmacros}

\usepackage{graphicx}

\usepackage{listings}
\lstset{basicstyle=\small\ttfamily,
  keepspaces=true,
  columns=fullflexible}

\setlength{\parindent}{0em}\setlength{\parskip}{0.5ex}
\pagestyle{empty}
\begin{document}\thispagestyle{empty}
\makebox[\textwidth]{Questions for Two.V (part two)\hfill  From \textit{Theory of Computation}, by Hef{}feron}\vspace{-1ex}
\makebox[\textwidth]{\hbox{}\hrulefill\hbox{}}

\begin{questions}
\question 
Show that each of these problems is unsolvable
by applying Rice's Theorem.
\begin{parts}
\part Given $e$, does $\TM_e$ halt on $5$?
\begin{solution}
We will show that 
$\mathcal{I}=\set{e\in\N\suchthat \TMfcn_e(5)\converges}$
is a nontrivial index set.
Then Rice's theorem will give that 
the problem of determining membership in~$\mathcal{I}$
is algorithmically unsolvable. 

First we argue that~$\mathcal{I}\neq\emptyset$.
This sketches a routine that is intuitively computable
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts012.pdf}}
\end{center}
so by Church's Thesis there is such a Turing machine.
That machine's index is an element of~$\mathcal{I}$.

Next we argue that~$\mathcal{I}\neq\N$.
The sketch
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts013.pdf}}
\end{center}
is intuitively computable, so 
by Church's Thesis there is such a Turing machine.
Its index is not an element of~$\mathcal{I}$.

To finish, we show that $\mathcal{I}$ is an index set.
Suppose that $e\in\mathcal{I}$ and that $\hat{e}$ is such that 
$\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$.
Because $e\in\mathcal{I}$, we have that $\TMfcn_e(5)\converges$.
Because $\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$,
we have that $\TMfcn_{\hat{e}}(5)\converges$ also.
Thus, $\hat{e}\in\mathcal{I}$.
Consequently, $\mathcal{I}$ is an index set.
\end{solution}

\part Given $e$, does $\TMfcn_e(4)$ converge and equal $7$?
\begin{solution}
Let
$\mathcal{I}=\set{e\in\N\suchthat \TMfcn_e(4)=7}$.
We will show that it 
is a nontrivial index set.

First we argue that~$\mathcal{I}\neq\emptyset$.
This sketch is intuitively computable
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts014.pdf}}
\end{center}
so by Church's Thesis there is such a Turing machine.
That machine's index is an element of~$\mathcal{I}$.

Next we argue that~$\mathcal{I}\neq\N$.
The sketch is intuitively computable
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts015.pdf}}
\end{center}
so 
by Church's Thesis there is such a Turing machine.
Its index is not an element of~$\mathcal{I}$.

To finish, we show that $\mathcal{I}$ is an index set.
Suppose that $e\in\mathcal{I}$ and that $\hat{e}$ is such that 
$\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$.
Because $e\in\mathcal{I}$, we have that $\TMfcn_e(4)=7$.
Because $\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$,
we have that $\TMfcn_{\hat{e}}(4)=7$ also.
Thus, $\hat{e}\in\mathcal{I}$.
Consequently, $\mathcal{I}$ is an index set.
\end{solution}

\part Given $e$, does $\TMfcn_e(a)$ converge and equal $a^2$ for all $a\in\N$?
\begin{solution}
We will show that 
$\mathcal{I}=\set{e\in\N\suchthat \text{$\TMfcn_e(a)=a^2$ for all $a$}}$
is a nontrivial index set.

First we prove that~$\mathcal{I}\neq\emptyset$.
This sketch is intuitively computable
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts016.pdf}}
\end{center}
so by Church's Thesis there is such a Turing machine.
That machine's index is an element of~$\mathcal{I}$.

Next we argue that~$\mathcal{I}\neq\N$.
The sketch is intuitively computable
\begin{center}
  \vcenteredhbox{\includegraphics{asy/flowcharts017.pdf}}
\end{center}
so 
by Church's Thesis there is such a Turing machine.
Its index is not an element of~$\mathcal{I}$.

To finish, we show that $\mathcal{I}$ is an index set.
Suppose that $e\in\mathcal{I}$ and that $\hat{e}$ is such that 
$\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$.
Because $e\in\mathcal{I}$, we have that $\TMfcn_e(a)=a^2$ for all inputs~$a$.
Because $\TMfcn_e\samebehavior\TMfcn_{\hat{e}}$,
we have that $\TMfcn_{\hat{e}}(a)=a^2$ for all~$a$ also.
Thus, $\hat{e}\in\mathcal{I}$.
Consequently, $\mathcal{I}$ is an index set.
\end{solution}
\end{parts}
\end{questions}
\end{document}
